> For the complete documentation index, see [llms.txt](https://docs.mailtrap.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.mailtrap.io/developers/account-management/permissions/manage-user-or-token-permissions.md).

# Manage user or token permissions

Manage user or token permissions. For this endpoint, you should send an array of objects (in JSON format) as the body of the request. If you send a combination of **resource\_type** and **resource\_id** that already exists, the permission is **updated**. If the combination doesn't exist, the permission is **created**. Permissions of an expired API token cannot be updated; such requests are rejected with a 422 error.

```json
{"openapi":"3.1.0","info":{"title":"Account Management","version":"2.0.0"},"tags":[{"name":"Permissions"}],"servers":[{"description":"Mailtrap API","url":"https://mailtrap.io"}],"security":[{"HeaderAuth":[]},{"BearerAuth":[]}],"components":{"securitySchemes":{"HeaderAuth":{"type":"apiKey","description":"Pass the API token in the Api-Token","in":"header","name":"Api-Token"},"BearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"responses":{"UNAUTHENTICATED":{"description":"Returns unauthorized error message. Check your credentials.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/UnauthenticatedResponse"}}}},"PERMISSION_DENIED":{"description":"Returns forbidden error message. Check your permissions.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PermissionsDeniedResponse"}}}},"NOT_FOUND":{"description":"Returns not found error message","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFoundResponse"}}}},"UNPROCESSABLE_ENTITY":{"description":"Validation error or other business rule violation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/UnprocessableEntity"}}}}},"schemas":{"UnauthenticatedResponse":{"title":"UnauthenticatedResponse","type":"object","properties":{"error":{"type":"string","description":"Error message"}}},"PermissionsDeniedResponse":{"title":"PermissionsDeniedResponse","type":"object","properties":{"errors":{"type":"string"}}},"NotFoundResponse":{"title":"NotFoundResponse","type":"object","properties":{"error":{"type":"string","description":"Error message"}}},"UnprocessableEntity":{"title":"UnprocessableEntity","type":"object","properties":{"errors":{"type":"object","description":"Validation errors per attribute. Entire record errors are under `base` key.","additionalProperties":{"type":"array","items":{"type":"string"}}}}}}},"paths":{"/api/account_accesses/{account_access_id}/permissions/bulk":{"put":{"operationId":"updateUserPermissions","summary":"Manage user or token permissions","description":"Manage user or token permissions. For this endpoint, you should send an array of objects (in JSON format) as the body of the request.\nIf you send a combination of **resource_type** and **resource_id** that already exists, the permission is **updated**.\nIf the combination doesn't exist, the permission is **created**.\nPermissions of an expired API token cannot be updated; such requests are rejected with a 422 error.","tags":["Permissions"],"requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"permissions":{"type":"array","items":{"type":"object","properties":{"resource_id":{"type":"string"},"resource_type":{"type":"string","enum":["account","billing","project","sandbox","domain","email_campaign_permission_scope"]},"access_level":{"type":"string","additionalProperties":{"type":["string","integer"]},"description":"Use a number or string. The higher the number, the more rights the specifier has:\n- 100 or \"admin\"\n- 10 or \"viewer\""},"_destroy":{"type":"boolean","description":"(Optional) If true, instead of creating/updating the permission, it destroys it."}}}}}}}}},"responses":{"200":{"description":"Returns message about successful update of permissions.","content":{"application/json":{"schema":{"type":"object","properties":{"message":{"type":"string"}}}}}},"401":{"$ref":"#/components/responses/UNAUTHENTICATED"},"403":{"$ref":"#/components/responses/PERMISSION_DENIED"},"404":{"$ref":"#/components/responses/NOT_FOUND"},"422":{"$ref":"#/components/responses/UNPROCESSABLE_ENTITY"}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.mailtrap.io/developers/account-management/permissions/manage-user-or-token-permissions.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
